package ru.ulstu.target;

import ru.ulstu.datamodel.exception.ModelingException;
import ru.ulstu.datamodel.ts.TimeSeries;

import java.lang.reflect.InvocationTargetException;
import java.util.concurrent.ExecutionException;

public abstract class Target {
    private final String name;

    public Target(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public abstract TimeSeries calculate(TimeSeries model) throws ModelingException, ExecutionException, InterruptedException, InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException;

}
